
#ifndef MGA_MGAREGISTRAR_H
#define MGA_MGAREGISTRAR_H

#include "CommonVersionInfo.h"
// --------------------------- CMgaRegistrar

class ATL_NO_VTABLE CMgaRegistrar : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CMgaRegistrar, &CLSID_MgaRegistrar>,
	public IDispatchImpl<IMgaRegistrar, &IID_IMgaRegistrar, &LIBID_MGAUTILLib>,
	public IMgaVersionInfoImpl
{
public:
	CMgaRegistrar() { }

DECLARE_REGISTRY_RESOURCEID(IDR_MGAREGISTRAR)
DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CMgaRegistrar)
	COM_INTERFACE_ENTRY(IMgaRegistrar)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY_IID(IID_IMgaVersionInfo, IMgaVersionInfoImpl)
END_COM_MAP()

// ------- Methods

public:
	STDMETHOD(get_IconPath)(regaccessmode_enum mode, BSTR *path);
	STDMETHOD(put_IconPath)(regaccessmode_enum mode, BSTR path);
	STDMETHOD(get_ShowMultipleView)(regaccessmode_enum mode, VARIANT_BOOL *enabled);
	STDMETHOD(put_ShowMultipleView)(regaccessmode_enum mode, VARIANT_BOOL enabled);
	STDMETHOD(get_EventLoggingEnabled)(regaccessmode_enum mode, VARIANT_BOOL *enabled);
	STDMETHOD(put_EventLoggingEnabled)(regaccessmode_enum mode, VARIANT_BOOL enabled);
	STDMETHOD(get_AutosaveEnabled)(regaccessmode_enum mode, VARIANT_BOOL *enabled);
	STDMETHOD(put_AutosaveEnabled)(regaccessmode_enum mode, VARIANT_BOOL enabled);
	STDMETHOD(get_AutosaveFreq)(regaccessmode_enum mode, long *secs);
	STDMETHOD(put_AutosaveFreq)(regaccessmode_enum mode, long secs);
	STDMETHOD(get_AutosaveUseDir)(regaccessmode_enum mode, VARIANT_BOOL *use);
	STDMETHOD(put_AutosaveUseDir)(regaccessmode_enum mode, VARIANT_BOOL use);
	STDMETHOD(get_AutosaveDir)(regaccessmode_enum mode, BSTR *dir);
	STDMETHOD(put_AutosaveDir)(regaccessmode_enum mode, BSTR dir);
	STDMETHOD(get_ExternalEditorEnabled)(regaccessmode_enum mode, VARIANT_BOOL *enabled);
	STDMETHOD(put_ExternalEditorEnabled)(regaccessmode_enum mode, VARIANT_BOOL enabled);
	STDMETHOD(get_ExternalEditor)(regaccessmode_enum mode, BSTR *path);
	STDMETHOD(put_ExternalEditor)(regaccessmode_enum mode, BSTR path);
	STDMETHOD(get_LabelAvoidance)(regaccessmode_enum mode, VARIANT_BOOL *enabled);
	STDMETHOD(put_LabelAvoidance)(regaccessmode_enum mode, VARIANT_BOOL enabled);
	STDMETHOD(get_ScriptEngine)(regaccessmode_enum mode, BSTR *path);
	STDMETHOD(put_ScriptEngine)(regaccessmode_enum mode, BSTR path);
	STDMETHOD(GetDefZoomLevel)(regaccessmode_enum mode, BSTR *zlevel);
	STDMETHOD(SetDefZoomLevel)(regaccessmode_enum mode, BSTR zlevel);
	STDMETHOD(GetMouseOverNotify)(regaccessmode_enum mode, VARIANT_BOOL *enabled);
	STDMETHOD(SetMouseOverNotify)(regaccessmode_enum mode, VARIANT_BOOL enabled);
	STDMETHOD(GetRealNmbFmtStr)(regaccessmode_enum mode, BSTR *fmtStr);
	STDMETHOD(SetRealNmbFmtStr)(regaccessmode_enum mode, BSTR fmtStr);

	STDMETHOD(get_Paradigms)(regaccessmode_enum mode, VARIANT *names);
	STDMETHOD(RegisterParadigmFromData)(BSTR connstr, BSTR *newname, regaccessmode_enum mode);
	STDMETHOD(RegisterParadigm)(BSTR name, BSTR connstr, BSTR version, VARIANT guid, regaccessmode_enum mode);
	STDMETHOD(QueryParadigmAllGUIDs)(BSTR name, VARIANT *names, regaccessmode_enum mode);
	STDMETHOD(QueryParadigm)(BSTR name, BSTR *connstr, VARIANT *quid, regaccessmode_enum mode);
	STDMETHOD(get_ParadigmGUIDString)(regaccessmode_enum mode, BSTR name, BSTR *guidstr);
	STDMETHOD(UnregisterParadigmGUID)(BSTR name, VARIANT v, regaccessmode_enum mode);
	STDMETHOD(UnregisterParadigm)(BSTR name, regaccessmode_enum mode);
	STDMETHOD(VersionFromGUID)(BSTR name, VARIANT guid, BSTR *ver, regaccessmode_enum mode);
	STDMETHOD(GUIDFromVersion)(BSTR name, BSTR ver, VARIANT* guid, regaccessmode_enum mode);

	STDMETHOD(get_Components)(regaccessmode_enum mode, VARIANT *progids);
	STDMETHOD(RegisterComponent)(BSTR progid, componenttype_enum type, BSTR desc, regaccessmode_enum mode);
	STDMETHOD(QueryComponent)(BSTR progid, componenttype_enum *type, BSTR *desc, regaccessmode_enum mode);
	STDMETHOD(UnregisterComponent)(BSTR progid, regaccessmode_enum mode);
	STDMETHOD(put_ComponentExtraInfo)(regaccessmode_enum mode, 
										BSTR progid, BSTR name, BSTR newVal);
	STDMETHOD(get_ComponentExtraInfo)(regaccessmode_enum mode, 
										BSTR progid, BSTR name, BSTR* pVal);
	STDMETHOD(get_LocalDllPath)(BSTR progid, BSTR* pVal);

	HRESULT LocalDllPath(BSTR progid,BSTR *pVal);

	STDMETHOD(get_AssociatedComponents)(BSTR paradigm, componenttype_enum type, regaccessmode_enum mode, VARIANT *progids);
	STDMETHOD(get_AssociatedParadigms)(BSTR progid, regaccessmode_enum mode, VARIANT *paradigms);
	STDMETHOD(Associate)(BSTR progid, BSTR paradigm, regaccessmode_enum mode);
	STDMETHOD(Disassociate)(BSTR progid, BSTR paradigm, regaccessmode_enum mode);
	STDMETHOD(IsAssociated)(BSTR progid, BSTR paradigm, VARIANT_BOOL *is_ass, VARIANT_BOOL *can_ass, regaccessmode_enum mode);

// --- Actions

	STDMETHOD(RegisterComponentLibrary)(BSTR path, regaccessmode_enum mode);
	STDMETHOD(UnregisterComponentLibrary)(BSTR path, regaccessmode_enum mode);
};

#endif//MGA_MGAREGISTRAR_H
